#include <stdio.h>
#include <stdarg.h>
#include <fcntl.h>
#include <string.h>
#include "crcmodel.c"

static   unsigned char buforg[0x40001];

// 27.10.2008 okaegi generate crc 32
unsigned long crc_32(unsigned char *buf,unsigned int len){
    //
    cm_t cmt;
    p_cm_t pcmt;
    int i;
    unsigned long crc;
    pcmt=&cmt;
    pcmt->cm_width = 32;             
    pcmt->cm_poly  = 0x4C11DB7L;                                       
    pcmt->cm_init  = 0xFFFFFFFFL;  
    pcmt->cm_refin = TRUE;
    pcmt->cm_refot = TRUE;
    pcmt->cm_xorot = 0xFFFFFFFFL;     
    
    cm_ini(pcmt);
    cm_blk(pcmt,buf,len);
    
    crc=cm_crc(pcmt);
    return(crc);
};


main(int argc,char *argv[])
{	
  unsigned long crc32r;
  int finorg;
  long n;
  char fileorg[60];

 if ((argc < 2) || (argc > 3)){
 	printf("gencrc32 file1 file2\n");
 	return -1;
 }

  printf("gencrc32 from file (%s) and file (%s) \n", argv[1], argv[2]) ;  
  printf("by okaegi v1.01 \n");    	
  sprintf(fileorg,"%s",argv[1]);
  finorg = open(fileorg,O_RDONLY|O_BINARY);
  if (finorg == -1) {
	  	printf("cant open %s...\n", fileorg);  
         	return -1;
 	}
  memset(buforg,0x00,0x40000);
  n= read(finorg,buforg,0x40000);	
  crc32r=crc_32(buforg,n);
  close(finorg);
  printf("gencrc32 read %06u bytes  from %s -> CRC32  %x\n",n,fileorg,crc32r);
  if (argc == 2) return 0;
  sprintf(fileorg,"%s",argv[2]);
  finorg = open(fileorg,O_RDONLY|O_BINARY);
  if (finorg == -1) {
	  	printf("cant open %s...\n", fileorg);  
         	return -1;
 	}
  memset(buforg,0x00,0x40000);
  n= read(finorg,buforg,0x40000);	
  crc32r=crc_32(buforg,n);
  close(finorg);
  printf("gencrc32 read %06u bytes  from %s -> CRC32  %x\n",n,fileorg,crc32r);

}
