#include <stdio.h>
#include <stdarg.h>
#include <fcntl.h>
#include <string.h>
#include "crcmodel.c"

static   unsigned char buforg[66001];
static   unsigned char bufmem[66001];
static   unsigned char bufcus[66001];
static   unsigned char bufpat[150001];
//
// 27.10.2008 okaegi generate patchinfo based on orginal rom , custom rom and memmap
// memmap is a file with 64k and describes what to do with the memory location in the custom.rom
// 00 -> XOR custom rom and orginal rom -> result patchfile
// FF -> move 00 in custom rom and orginal rom -> move 00 into patchfile
// 01 -> move 00 in orignal rom -> move custom rom into patchfile
// patchfile -> one byte holds information from memmap, next byte holds result (patchfile has size 128k)
// after the patchfile is created, crc-32 is calculated over orignal rom, then crc-32 result is sored in patchfile
unsigned long crc_32(unsigned char *buf,unsigned int len){
    //
    cm_t cmt;
    p_cm_t pcmt;
    int i;
    unsigned long crc;
    pcmt=&cmt;
    pcmt->cm_width = 32;             
    pcmt->cm_poly  = 0x4C11DB7L;                                       
    pcmt->cm_init  = 0xFFFFFFFFL;  
    pcmt->cm_refin = TRUE;
    pcmt->cm_refot = TRUE;
    pcmt->cm_xorot = 0xFFFFFFFFL;     
    
    cm_ini(pcmt);
    cm_blk(pcmt,buf,len);
    
    crc=cm_crc(pcmt);
    return(crc);
};
main(int argc,char *argv[])
{	
  unsigned long crc32;
  int finorg,finmem,finout,fincus,fout;
  long i;
  char fileout[60];
  char fileorg[60];  
  char filemem[60];
  char filecus[60];

 if (argc != 5) {
 	printf("genpatch rom.org custom.org memmap.org outputpatchfile\n");
 	return -1;
 }

  printf("genpatch:create patchinfo orignal rom (%s) custom rom (%s) memmap (%s) outputpatchfile %s\n", argv[1],argv[2],argv[3],argv[4]) ;  
  printf("by okaegi v1.2 \n");    	
  sprintf(fileorg,"%s",argv[1]);
  sprintf(filecus,"%s",argv[2]);
  sprintf(filemem,"%s",argv[3]);
  sprintf(fileout,"%s",argv[4]);
  finorg = open(fileorg,O_RDONLY|O_BINARY);
  if (finorg == -1) {
	  	printf("cant open %s...\n", fileorg);  
         	return -1;
 	}
  read(finorg,buforg,0x10000);	
  close(finorg);
  finmem = open(filemem,O_RDONLY|O_BINARY);
  if (finmem == -1) {
	  	printf("cant open %s...\n", filemem);  
         	return -1;
 	}
  read(finmem,bufmem,0x10000);	
  close(finmem);

  fincus = open(filecus,O_RDONLY|O_BINARY);
  if (fincus == -1) {
	  	printf("cant open %s...\n", filecus);  
         	return -1;
 	}
  read(fincus,bufcus,0x10000);	
  close(fincus);


  memset(bufpat,0x00,150000);
  for (i = 0 ;i<=0x10000;i++) {
// FF erase in buforg
      if (bufmem[i] == 0xff) {
      		buforg[i] = 0x00;
                bufpat[(i*2)] = 0xff;
                bufpat[(i*2)+1] = 0x00;
  	  } 
// 01 move from bufcus 	  
      else if (bufmem[i] == 0x01) {
      		buforg[i] = 0x00;
                bufpat[(i*2)] = 0x01;
                bufpat[(i*2)+1] = bufcus[i];
  	  } 
// 00 xor buforg with bufcus  	  
      else if (bufmem[i] == 0x00) {
                bufpat[(i*2)] = 0x00;
                bufpat[(i*2)+1] = buforg[i] ^ bufcus[i];
// org custom -> patch (xor)   org -> custom (xor)
// 1     1    -> 0		1	1
// 1     0    -> 1		1       0
// 0     1    -> 1		0       1 
// 0     0    -> 0		0       0

          } 
      else {
      		printf ("memmap wrong byte %02x",bufmem[i]);
          	return -1;
      }
  } 
  crc32=crc_32(buforg,0x10000);
  printf("genpatch %s calculated %x\n",fileorg,crc32);
// sprintf(bufcrc,"%x\0",crc32);
  fout = creat(fileout,666);
  if (fout == -1) {
      printf("genpatch cant open %s as output\n", fileout);  
      return -1;
   }
  close(fout);
  fout = open(fileout,O_WRONLY|O_TRUNC|O_BINARY);
  if (fout == -1) {
      printf("genpatch cant open %s as output\n", fileout);  
      return -1;
  }
  memcpy(&bufpat[0x20010],&crc32,sizeof(crc32));
  write(fout,bufpat,0x20100);
  close(fout);


}
